#!/usr/bin/python

from os import getenv
from cgi import FieldStorage

fs = FieldStorage()
suffix = fs.getvalue('suffix', '')

if suffix != '.metalink':
	newurl = "http://%s%s&suffix=.metalink" % (getenv('SERVER_NAME'),getenv('REQUEST_URI'))
	print 'Status: 301 Metalink'
	print 'Location: %s\n' % newurl
else:
	type = fs.getvalue('type', 'distrib')
	version = fs.getvalue('version', '2008.1')
	arch = fs.getvalue('arch', 'x86_64')
	files = fs.getlist('file')

	if version == 'cooker':
		version = 2008.1

	from geomcfly import GeoMcFly
	geomc = GeoMcFly('dump-%s.%s.%s.dat' % (type,version,arch))
	geomc.metalink.identity = 'Mandriva Linux %s (%s)' % (version,arch)
	geomc.metalink.publisher_name = 'Mandriva'
	geomc.metalink.publisher_url = 'http://www.mandriva.com/'

	listurl = 'http://api.mandriva.com/mirrors/basic.%s.%s.list' % (version,arch)
	geomc.loadlist(listurl, reqtype=type)
	geomc.calcpref(getenv('REMOTE_ADDR'))
	geomc.addfiles(files)

	print 'Content-Type: application/metalink+xml\n'
	print geomc.getmetalink()
